//BilderKatalog2_514d.js
// 16.02.16 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Erzeugt einen Bilder-Katalog

//Ein JavaScript fr InDesign CS5, basierend auf dem Script "ImageCatalog.jsx" von Adobe
//bersetzt, optimiert und erweitert von Hans Haesler <hsa@ringier.ch>
//neue Erweiterungen im Februar 2016, aufgrund von Wnschen und Anregungen von Robert_P und Quarz

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var defStr = getPrefs();
// die Werte ausziehen, wenn die Vorgabendatei existiert
if (defStr != "") {
	var catDef = defStr.split("\n");
	mainFolder = catDef[0];
	fMan = catDef[1]*1;
	dSiz = catDef[2]*1;
	pSiz = catDef[3];
	mVal = catDef[4];
	rVal = catDef[5]*1;
	cVal = catDef[6]*1;
	vOff = catDef[7]*1;
	hOff = catDef[8]*1;
	aDir = catDef[9]*1;
	aSor = catDef[10]*1;
	dSor = catDef[11]*1;
	fTyp = catDef[12]*1;
	nNam = catDef[13]*1;
	sInf = catDef[14];
	if (sInf == "false") {sInf = false;}
	else {sInf = true;}
	pInf = catDef[15];
	if (pInf == "false") {pInf = false;}
	else {pInf = true;}
	tSiz = catDef[16]*1;
	jTyp = catDef[17]*1;
	rEmp = catDef[18];
	if (rEmp == "false") {rEmp = false;}
	else {rEmp = true;}
}
else { // wenn keine Vorgabendatei gefunden wurde
	mainFolder = "~/Documents";
	fMan = 1;
	dSiz = 3;
	pSiz = "240 180";
	mVal = "12 8 12 12";
	rVal = 3;
	cVal = 3;
	vOff = 18;
	hOff = 4;
	aDir = 0;
	aSor = 0;
	dSor = 0;
	fTyp = 1;
	nNam = 1;
	sInf = false;
	pInf = false;
	tSiz = 10;
	jTyp = 0;
	rEmp = true;
}

// 'sufString' ist eine globale Variable, enthlt eine Liste von Suffizes
sufString = "|.psd|.tif|.ai|.jpg|.pdf|.eps|.tiff|.png|.gif|";

// prfen, ob der gespeicherte Ordner existiert 
if (!Folder(mainFolder).exists) {
	mainFolder = "";
}

// den Dialog zur Ordnerauswahl anzeigen 
var selFolder = Folder(mainFolder).selectDlg("Der Quellordner (enthlt die zu ladenden Bilddateien)");

// wenn nicht "Abbrechen" geklickt ...
if (selFolder != null) {
	// ... den Pfad zum Hauptordner speichern
	mainFolder = selFolder.path;
	// vier Arrays vorbereiten
	var mainList = new Array();
	var foldList = new Array();
	var mainFileList = new Array();
	var subFileList  = new Array();
	var nMain = nSub = 0;

	// die Dateipfade im Hauptordner und die Unterordnerpfade holen
	var fileFold = getMainFiles(selFolder, mainList, foldList);
	
	mainFiles = fileFold[0];
	if (mainFiles.length > 0) {
		// zum Filtern schicken
		mainFileList = fileFilter1(mainFiles);
		nMain = mainFileList.length;
	}
	foldList  = fileFold[1];
	var nFold = foldList.length;
	if (nFold > 0) {
		var subsList = new Array();
		for (n=0; n<nFold; n++) {
			var tmpList = new Array();
			// die Dateipfade in den Unterordnern holen
			subsList = subsList.concat(getSubFiles(foldList[n], tmpList));
		}
		// zum Filtern schicken
		subFileList = fileFilter1(subsList);
		nSub = subFileList.length;
	}
	
	// die Anzahl Dateien (Total, Haupt- und Unterordner)
	var nAll = nMain + nSub;
	
	if (nAll == 0) {
		alert ("Der gewhlte Ordner enthlt keine Bilddateien, welche plaziert werden knnen.");
		exit();
	}
	
	// die Funktion aufrufen, welche den Dialog vorbereitet, anzeigt und auswertet
	askUser(nMain, nSub, nAll);
	
	// den Array der Bildpfade erstellen
	if (fMan == 0) {
		if (nMain > 0) {
			tmpList = mainFileList;
		}
		else {
			alert ("Der Hauptordner selbst enthlt keine Bilddateien.", "Stop");
			exit();
		}
	}
	else {
		if (nMain > 0 && nSub > 0) {
			tmpList = mainFileList.concat(subFileList);
		}
		else if (nMain > 0 && nSub == 0) {
			tmpList = mainFileList;
		}
		else if (nMain == 0 && nSub > 0) {
			tmpList = subFileList;
		}
	}
	if (aSor == 0) { // alphabetisch sortieren
		if (fMan == 0) { // nur Hauptordner
			if (dSor == 0) { // aufsteigend
				defList = tmpList.sort();
			}
			else if (dSor == 1) { // absteigend
				defList = tmpList.sort();
				defList.reverse();
			}
		}
		else { // auch Unterordner
			var namesArr = getNames(tmpList);
			// den Array sortieren
			namesArr.sort(function(a, b) {
				if (dSor == 0) { // aufsteigend
					return a[1] > b[1];
				}
				else if (dSor == 1) { // absteigend
					return a[1] < b[1];
				}
			});
			// dem definitiven Array zuweisen
			defList = namesArr;
		}
	}
	else if (aSor == 1) { // numerisch sortieren
		// die Anzahl Namen
		var nNames = tmpList.length;
		// das Ziffern-RegExp-Objekt
		var num = new RegExp("[0-9]+");
		// prfen, ob der erste Name eine Ziffer enthlt
		var pos = tmpList[0].name.search(num);
		if (pos == -1) {
			alert ("Der erste Name enthlt keine Zahl.", "Stop");
			exit();
		}
		var numbersArr = getNumbers(tmpList, nNames, num);
		// den Array sortieren
		numbersArr.sort(function(a, b) {
			if (dSor == 0) { // aufsteigend
				return a[1] - b[1];
			}
			else if (dSor == 1) { // absteigend
				return b[1] - a[1];
			}
		});
		// dem definitiven Array zuweisen
		defList = numbersArr;
	}
	else if (aSor == 2) { // Erstellungsdatum
		var datesArr = getDates(tmpList);
		// den Array sortieren
		datesArr.sort(function(a, b) {
			if (dSor == 0) { // aufsteigend
				return a[1] - b[1];
			}
			else if (dSor == 1) { // absteigend
				return b[1] - a[1];
			}
		});
		// dem definitiven Array zuweisen
		defList = datesArr;
	}
	// die Funktion zum Erzeugen des Bildkataloges aufrufen
	makeImageCatalog();
}

// die Funktion, welche die Dateien des Hauptordners auflistet (und die Unterordner)
function getMainFiles(selFolder, mainList, foldList) {
	var f = Folder(selFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			foldList.push(f[i]);
		}
		else {
			mainList.push(f[i]);
		}
	}
	return [mainList, foldList];
}

// die Funktion, welche die Dateien der Unterordner auflistet
function getSubFiles(subFolder, tmpList) {
	var f = Folder(subFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			getSubFiles(f[i], tmpList);
		}
		else {
			tmpList.push(f[i]);
		}
	}
	return tmpList;
}

// der erste Teil des Datei-Filters
function fileFilter1(subFiles){
	var curFileList = new Array();
	for (var i=0; i<subFiles.length; i++) {
		curFile = subFiles[i];
		if (fileFilter2(curFile)) {
			curFileList.push(curFile);
		}
	}
	return curFileList;
}

// der zweite Teil des Datei-Filters (Mac-OS-Version) des Datei-Filters
// notwendig, weil nicht alle Dateien mit Suffizes versehen sind 
// und/oder diese manchmal vom Finder verborgen werden
function fileFilter2(curFile){
	var curFileType = curFile.type;
	switch (curFileType){
		case "JPEG":
		case "EPSF":
		case "PICT":
		case "TIFF":
		case "8BPS":
		case "GIFf":
		case "PDF ":
			return true;
			break;
		default:
		var curName = curFile.name.toLowerCase();
		try {
			var curItems = curName.split(".");
			var curSuf = "|." + curItems[(curItems.length)-1] + "|";
			if (sufString.indexOf(curSuf) != -1) {
				return true;
			}
			else {
				return false;
			}
		}
		catch (e) {
			return false;
		}
	}
}

// die Funktion, welche die Informationen vorbereitet
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/cata514_2.txt");
	}
	else {
		var f = new File("~/Library/Preferences/cata514_2.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// die Funktion, welche den Dialog vorbereitet, anzeigt und auswertet
function askUser(nMain, nSub, nAll) {
	// Dialoge lschen, welche offen geblieben sind
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var labelWidth  = 135;
	var labelWidth2 =  94;
	var textWidth   = 206;
	var folList = new Array("nur Hauptordner", "auch Unterordner");
	var sizList = new Array("DIN A4 hoch", "DIN A4 quer", "DIN A3 hoch", "DIN A3 quer", "benutzerdefinierte ...");
	var creList = new Array("von links nach rechts", "von oben nach unten");
	var srtList = new Array("alphabetisch", "numerisch", "Erstellungsdatum");
	var dirList = new Array("aufsteigend", "absteigend");
	var fitList = new Array("proportional", "kleinstmgliches %", "100%", "Rahmen an Inhalt");
	var capList = new Array("keine", "Dateiname", "Dateiname ohne Suffix", "ganzer Pfad");
	var jstList = new Array("links", "zentriert", "rechts");

	var aDialog = app.dialogs.add({name:"BilderKatalog"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"" + nAll + " Dateien  (Hauptordner = " + nMain + " / Unterordner = " + nSub + ")"});
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Ordnerwahl", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var folArticle = dropdowns.add({stringList:folList, selectedIndex:fMan, minWidth:206});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Seitenformat", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var sizArticle = dropdowns.add({stringList:sizList, selectedIndex:dSiz, minWidth:206});
					}
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Seitenbreite + -hhe", minWidth:labelWidth});
							var pageSizeField = textEditboxes.add({editContents:pSiz, minWidth:84});
							staticTexts.add({staticLabel:"mm"});
						}
					}
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Seitenrnder", minWidth:labelWidth});
							var marginsField = textEditboxes.add({editContents:mVal, minWidth:84});
							staticTexts.add({staticLabel:"mm (y1 y2 x1 x2)"});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Reihen", minWidth:labelWidth});
					var nRowsField = integerEditboxes.add({editValue:rVal, minWidth:36});
					staticTexts.add({staticLabel:"Abstand Y", minWidth:labelWidth2});
					var verticalOffsetField = realEditboxes.add({editValue:vOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Kolonnen", minWidth:labelWidth});
					var nColumnsField = integerEditboxes.add({editValue:cVal, minWidth:36});
					staticTexts.add({staticLabel:"Abstand X", minWidth:labelWidth2});
					var horizontalOffsetField = realEditboxes.add({editValue:hOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Anordnung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var creArticle = dropdowns.add({stringList:creList, selectedIndex:aDir, minWidth:206});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Sortierung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var srtArticle = dropdowns.add({stringList:srtList, selectedIndex:aSor, minWidth:206});
					}
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Richtung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var dirArticle = dropdowns.add({stringList:dirList, selectedIndex:dSor, minWidth:206});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Bilder anpassen", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var fitArticle = dropdowns.add({stringList:fitList, selectedIndex:fTyp, minWidth:206});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Bildlegende", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var capArticle = dropdowns.add({stringList:capList, selectedIndex:nNam, minWidth:206});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Informationen", minWidth:labelWidth});
					with (dialogColumns.add()) {
						var sizeInfo = checkboxControls.add({staticLabel:"Breite mal Hhe (Original)", checkedState:sInf, minWidth:206});
						var ppiInfo  = checkboxControls.add({staticLabel:"ppi (exkl. \".eps\", \".pdf\", \".ai\")", checkedState:pInf});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Schriftgrad", minWidth:labelWidth});
					var typeSize = realEditboxes.add({editValue:tSiz, minWidth:36});
					staticTexts.add({staticLabel:"pt  "});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Ausrichtung", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var jstArticle = dropdowns.add({stringList:jstList, selectedIndex:jTyp, minWidth:206});
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:" ", minWidth:labelWidth+10});
			var removeEmptyFramesCheckbox = checkboxControls.add({staticLabel:"leere Rahmen entfernen", checkedState:rEmp});
		}
	}
	// den Dialog anzeigen und auswerten
	var dResult = aDialog.show();
	if (dResult == true) {
		// Hauptordner oder auch Unterordner
		fMan = folArticle.selectedIndex;
		// das Seitenformat
		tmpSiz = pageSizeField.editContents;
		dSiz = sizArticle.selectedIndex;
		if (dSiz == 0) {
			pW = 210;
			pH = 297;
		}
		else if (dSiz == 1) {
			pW = 297;
			pH = 210;
		}
		else if (dSiz == 2) {
			pW = 297;
			pH = 420;
		}
		else if (dSiz == 3) {
			pW = 420;
			pH = 297;
		}
		else if (dSiz == 4) {
			var tmpSize = tmpSiz.split(" ");
			if (tmpSize.length != 2) {
				alert ("Im benutzerdefinierten Feld bitte zwei Zahlen eintragen.");
				pSiz = tmpSiz;
				aDialog.destroy();
				exit();
			}
			pW = tmpSize[0]*1;
			if (isNaN(pW)) {
				alert ("Ungltiger Wert fr die Seitenbreite.");
				aDialog.destroy();
				exit();
			}
			pH = tmpSize[1]*1;
			if (isNaN(pH)) {
				alert ("Ungltiger Wert fr die Seitenhhe.");
				aDialog.destroy();
				exit();
			}
		}
		pSiz = tmpSiz;
		// die Seitenrnder
		mVal = marginsField.editContents;
		var mVals = mVal.split(" ");
		if (mVals.length == 1) {
			var oneVal = mVal*1;
			if (isNaN(oneVal)) {
				alert ("Ungltiger Wert fr die Rnder.");
				aDialog.destroy();
				exit();
			}
			marY1 = marY2 = marX1 = marX2 = oneVal;
		}
		else if (mVals.length == 4) {
			marY1 = mVals[0]*1;
			if (isNaN(marY1)) {
				alert ("Ungltiger Wert fr den oberen Rand.");
				aDialog.destroy();
				exit();
			}
			marY2 = mVals[1]*1;
			if (isNaN(marY2)) {
				alert ("Ungltiger Wert fr den unteren Rand.");
				aDialog.destroy();
				exit();
			}
			marX1 = mVals[2]*1;
			if (isNaN(marX1)) {
				alert ("Ungltiger Wert fr den linken Rand.");
				aDialog.destroy();
				exit();
			}
			marX2 = mVals[3]*1;
			if (isNaN(marX2)) {
				alert ("Ungltiger Wert fr den rechten Rand.");
				aDialog.destroy();
				exit();
			}
		}
		else {
			alert ("Im Feld fr die Rnder entweder einen oder vier Werte eingeben.");
			aDialog.destroy();
			exit();
		}
		var nRows = nRowsField.editValue;
		rVal = nRows;
		var nColumns = nColumnsField.editValue;
		cVal = nColumns;
		var verticalOffset = verticalOffsetField.editValue;
		vOff = verticalOffset;
		var horizontalOffset = horizontalOffsetField.editValue;
		hOff = horizontalOffset;
		// die Anordnung
		aDir = creArticle.selectedIndex;
		// die Sortierung
		aSor = srtArticle.selectedIndex;
		dSor = dirArticle.selectedIndex;
		// Bilder anpassen
		fTyp = fitArticle.selectedIndex;
		// die Bildlegende
		nNam = capArticle.selectedIndex;
		// die Informationen
		sInf = sizeInfo.checkedState;
		pInf= ppiInfo.checkedState;
		// der Schriftgrad
		tSiz = typeSize.editValue;
		// die Ausrichtung
		var justType = jstArticle.selectedIndex;
		if (justType == 0) {
			txtJust = Justification.leftAlign;
		}
		else if (justType == 1) {
			txtJust = Justification.centerAlign;
		}
		else if (justType == 2) {
			txtJust = Justification.rightAlign;
		}
		// leere Rahmen entfernen
		var removeEmptyFrames = removeEmptyFramesCheckbox.checkedState;
		rEmp = removeEmptyFrames;
		aDialog.destroy();
		
		// die Liste der Einstellungen ...
		var prefsList = new Array(mainFolder,fMan,dSiz,pSiz,mVal,rVal,cVal,vOff,hOff,aDir,aSor,dSor,fTyp,nNam,sInf,pInf,tSiz,justType,rEmp);
		// ... in eine Textkette verwandeln ...
		var curDef = prefsList.join("\n");
		// ... zur Funktion schicken, welche sie in eine Datei schreibt
		writeResult(curDef);
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// die Namen feststellen
function getNames(tmpList) {
	namesArr = new Array();
	for (var n=0; n<tmpList.length; n++) {
		var curName = tmpList[n].name;
		namesArr.push([tmpList[n], curName]);
	}
	return namesArr;
}

// die Erzeugungsdaten feststellen
function getDates(tmpList) {
	// ein temporres Dokument und einen Bildrahmen erzeugen
	var tmpDoc = app.documents.add(false);
	var tmpFrm = tmpDoc.rectangles.add();
	datesArr = new Array();

	for (var n=0; n<tmpList.length; n++) {
		// das aktuelle Bild laden 
		var curImage = tmpList[n];
		tmpFrm.place(curImage);
		// das Datum feststellen
		try {
			var curTime = (tmpDoc.links[0].linkXmp.creationDate).getTime();
		}
		catch (e) {
			var curTime = (tmpList[n].created).getTime();
		}
		datesArr.push([tmpList[n], curTime]);
	}
	// das temporre Dokument schliessen
	tmpDoc.close(SaveOptions.no);
	return datesArr;
}

// die Zahlen ausziehen, einen neuen Array bilden
function getNumbers(tmpList, nNames, num) {
	numbersArr = new Array();
	for (var n=0; n<nNames; n++) {
		var numVal = tmpList[n].name.match(num);
		numbersArr.push([tmpList[n], numVal]);
	}
	return numbersArr;
}

// das Ergebnis in eine Datei schreiben
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/cata514_2.txt");
	}
	else {
		var f = File("~/Library/Preferences/cata514_2.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Funktion, welche das Dokument und die Rahmen erzeugt, 
// die Bilder importiert und bei Bedarf die Bildlegenden einsetzt
function makeImageCatalog(){
	var curPage, curFile, x1, y1, x2, y2, curRect, objStyle, labelStyle, labelLayer;
	var framesPerPage = rVal * cVal;
	var marginPrefs = app.marginPreferences;
	var oldY1 = marginPrefs.top;
	var oldX1 = marginPrefs.left;
	var oldY2 = marginPrefs.bottom;
	var oldX2 = marginPrefs.right;
	marginPrefs.top = marY1;
	marginPrefs.left = marX1;
	marginPrefs.bottom = marY2;
	marginPrefs.right = marX2;
	var curDoc = app.documents.add();
	app.marginPreferences.top = oldY1;
	app.marginPreferences.left = oldX1;
	app.marginPreferences.bottom = oldY2;
	app.marginPreferences.right = oldX2;
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	var docPrefs = curDoc.documentPreferences;
	var nFrames = defList.length;
	var nPages = Math.round(nFrames / framesPerPage);
	if ((nPages*framesPerPage) < nFrames) {
		nPages++;
	}
	docPrefs.pageWidth = pW;
	docPrefs.pageHeight = pH;
	docPrefs.pagesPerDocument = nPages;
	docPrefs.facingPages = false;
	var liveWidth = (pW - ((marX1) + (marX2))) + hOff;
	var liveHeight = pH - ((marY1) + (marY2));
	var columnWidth = liveWidth / cVal;
	var frameWidth = columnWidth - hOff;
	var rowHeight = (liveHeight / rVal);
	var frameHeight = rowHeight - vOff;
	var allPages = curDoc.pages;
	// das Objektformat "Box" erzeugen
	objStyle = curDoc.objectStyles.itemByName("Box");
	try {
		objStyle.name;
	}
	catch (e) {
		objStyle = curDoc.objectStyles.add();
		objStyle.name = "Box";
		objStyle.strokeWeight = 0;
	}
	if (nNam > 0){
		// das Absatzformat "Bildlegende" erzeugen
		labelStyle = curDoc.paragraphStyles.itemByName("Bildlegende");
		try {
			labelStyle.name;
		}
		catch (e) {
			labelStyle = curDoc.paragraphStyles.add();
			labelStyle.name = "Bildlegende";
		}
		labelStyle.pointSize = tSiz;
		labelStyle.justification = txtJust;
		// die Ebene "Bildlegenden" erzeugen
		var labelLayer = curDoc.layers.itemByName("Bildlegenden");
		try {
			labelLayer.name;
		}
		catch (e){
			labelLayer = curDoc.layers.add();
			labelLayer.name = "Bildlegenden";
		}
	}
	// die Rahmen rckwrts aufbauen
	var curPage;
	var noColor = curDoc.swatches.itemByName("None");
	for (p = curDoc.pages.length-1; p>=0; p--) {
		curPage = allPages.item(p); 
		if (aDir == 0) {
			for (var j=rVal; j>=1; j--) {
				y1 = marY1+(rowHeight*(j-1));
				y2 = y1+frameHeight;
				for (var k=cVal; k>=1; k--) {
					x1 = marX1+(columnWidth*(k-1));
					x2 = x1+frameWidth;
					curPage.rectangles.add(curDoc.layers.item(-1), undefined, undefined, {geometricBounds:[y1, x1, y2, x2], appliedObjectStyle:objStyle});
				}
			}
		}
		else {
			for (var k=cVal; k>=1; k--) {
				x1 = marX1+(columnWidth*(k-1));
				x2 = x1+frameWidth;
				for (var j=rVal; j>=1; j--) {
					y1 = marY1+(rowHeight*(j-1));
					y2 = y1+frameHeight;
					curPage.rectangles.add(curDoc.layers.item(-1), undefined, undefined, {geometricBounds:[y1, x1, y2, x2], appliedObjectStyle:objStyle});
				}
			}
		}
	}
	
	// weil die Rahmen in umgekehrter Reihenfolge erzeugt worden sind, 
	// knnen wir das Laden der Bilder vorwrts durchfhren
	var cS, rawW, rawH, imgW, imgH, curSize, curRes;
	var oldPc, newPc, pathItems, labelString, curItems, curSuf;
	for (i = 0; i < nFrames; i++) {
		if (fMan == 1 || aSor == 1 || aSor == 2) {
			curFile = defList[i][0];
		}
		else {
			curFile = defList[i];
		}
		curRect = curDoc.rectangles.item(i);
		try {
			curRect.place(File(curFile));
			cS = curRect.allGraphics[0].geometricBounds;
			rawW = cS[3]-cS[1];
			rawH = cS[2]-cS[0];
			imgW = (Math.floor(((rawW * 1000) + 0.5)))/1000;
			imgH = (Math.floor(((rawH * 1000) + 0.5)))/1000;
			curSize = imgW + " x " + imgH + " mm";
			actRes = -1;
			try {
				var actRes = curRect.allGraphics[0].actualPpi[0];
			}
			catch (e) {
			}
			var curPath = curRect.graphics[0].itemLink.filePath;
			if (curPath.indexOf("\u0300") != -1) {
				curPath = rep1(curPath);
			}
			if (curPath.indexOf("\u0301") != -1) {
				curPath = rep2(curPath);
			}
			if (curPath.indexOf("\u0302") != -1) {
				curPath = rep3(curPath);
			}
			if (curPath.indexOf("\u0303") != -1) {
				curPath = rep4(curPath);
			}
			if (curPath.indexOf("\u0308") != -1) {
				curPath = rep5(curPath);
			}
			if (curPath.indexOf("\u030A") != -1) {
				curPath = rep6(curPath);
			}
			if (curPath.indexOf("\u0327") != -1) {
				curPath = rep7(curPath);
			}
			// die Anpassen-Optionen zuweisen
			if (fTyp == 0) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			else if (fTyp == 1) {
				// den Inhalt des Rahmens proportional anpassen
				curRect.fit(FitOptions.FILL_PROPORTIONALLY);
				// die Bildgrsse feststellen
				oldPc = curRect.allGraphics[0].horizontalScale;
				// den Wert um 0.2% erhhen und auf eine Nachkommastelle abrunden
				newPc = Math.ceil((oldPc + 0.2)*10) / 10;
				// den neuen Wert zuweisen
				curRect.allGraphics[0].properties = {horizontalScale:newPc, verticalScale:newPc};
				// das Bild zentrieren
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			else if (fTyp == 3) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.FRAME_TO_CONTENT);
			}
			effRes = -1;
			try {
				var effRes = curRect.allGraphics[0].effectivePpi[0];
			}
			catch (e) {
			}
			// die Bildlegende einfgen, falls gewnscht
			if (nNam > 0) {
				x1 = curRect.geometricBounds[1];
				y1 = curRect.geometricBounds[2];
				x2 = curRect.geometricBounds[3];
				y2 = curRect.geometricBounds[2]+vOff;
					pathItems = curPath.split(":");
				if (nNam == 1) {
					labelString = pathItems[(pathItems.length)-1];
				}
				else if (nNam == 2) {
					tmpString = pathItems[(pathItems.length)-1];
					tmpArray  = tmpString.split(".");
					var nItems = tmpArray.length;
					if (nItems == 1) {
						labelString = tmpString;
					}
					else if (nItems == 2) {
						labelString = tmpArray[0];
					}
					else if (nItems > 2) {
						tmpArray.pop();
						labelString = tmpArray.join(".");
					}
				}
				else if (nNam == 3) {
					labelString = curPath;
				}
				try {
					if (actRes != -1) {
						if (sInf && pInf) {
							labelString = labelString + "\n" + curSize + "\noriginal: " + actRes + " ppi / effektiv: " + effRes + " ppi";
						}
						else if (sInf) {
							labelString = labelString + "\n" + curSize;
						}
						else if (pInf) {
							labelString = labelString + "\noriginal: " + actRes + " ppi / effektiv: " + effRes + " ppi";
						}
					}
					else {
						if (sInf) {
							labelString = labelString + "\n" + curSize;
						}
					}
				}
				catch (e) {
				}
				textFrame = curRect.parent.textFrames.add(labelLayer, undefined, undefined,{geometricBounds:[y1, x1, y2, x2], contents:labelString});
				textFrame.textFramePreferences.firstBaselineOffset = FirstBaseline.leadingOffset;
				textFrame.texts[0].appliedParagraphStyle = labelStyle;
			}
		}
		catch (e) {
		}
	}
	// eventuell leergebliebene Rahmen entfernen, falls gewnscht
	if (rEmp == 1) {
		for (var i = curDoc.rectangles.length-1; i >= 0; i--) {
			if (curDoc.rectangles.item(i).contentType == ContentType.unassigned) {
				curDoc.rectangles.item(i).remove();
			}
			else {
				// sobald ein Rahmen mit Inhalt angetroffen wird, die Schleife verlassen
				break;
			}
		}
	}
}

// die Funktionen, welche Akzentbuchstaben in ein einzelnes Zeichen verwandeln
function rep1(curPath) {
	curPath = curPath.replace(/a\u0300/g, '').replace(/A\u0300/g, '');
	curPath = curPath.replace(/e\u0300/g, '').replace(/E\u0300/g, '');
	curPath = curPath.replace(/i\u0300/g, '').replace(/I\u0300/g, '');
	curPath = curPath.replace(/o\u0300/g, '').replace(/O\u0300/g, '');
	curPath = curPath.replace(/u\u0300/g, '').replace(/U\u0300/g, '');
	return curPath;
}

function rep2(curPath) {
	curPath = curPath.replace(/a\u0301/g, '').replace(/A\u0301/g, '');
	curPath = curPath.replace(/e\u0301/g, '').replace(/E\u0301/g, '');
	curPath = curPath.replace(/i\u0301/g, '').replace(/I\u0301/g, '');
	curPath = curPath.replace(/o\u0301/g, '').replace(/O\u0301/g, '');
	curPath = curPath.replace(/u\u0301/g, '').replace(/U\u0301/g, '');
	return curPath;
}

function rep3(curPath) {
	curPath = curPath.replace(/a\u0302/g, '').replace(/A\u0302/g, '');
	curPath = curPath.replace(/e\u0302/g, '').replace(/E\u0302/g, '');
	curPath = curPath.replace(/i\u0302/g, '').replace(/I\u0302/g, '');
	curPath = curPath.replace(/o\u0302/g, '').replace(/O\u0302/g, '');
	curPath = curPath.replace(/u\u0302/g, '').replace(/U\u0302/g, '');
	return curPath;
}

function rep4(curPath) {
	curPath = curPath.replace(/a\u0303/g, '').replace(/A\u0303/g, '');
	curPath = curPath.replace(/n\u0303/g, '').replace(/N\u0303/g, '');
	curPath = curPath.replace(/o\u0303/g, '').replace(/O\u0303/g, '');
	return curPath;
}

function rep5(curPath) {
	curPath = curPath.replace(/a\u0308/g, '').replace(/A\u0308/g, '');
	curPath = curPath.replace(/e\u0308/g, '').replace(/E\u0308/g, '');
	curPath = curPath.replace(/i\u0308/g, '').replace(/I\u0308/g, '');
	curPath = curPath.replace(/o\u0308/g, '').replace(/O\u0308/g, '');
	curPath = curPath.replace(/u\u0308/g, '').replace(/U\u0308/g, '');
	curPath = curPath.replace(/y\u0308/g, '').replace(/Y\u0308/g, '');
	return curPath;
}

function rep6(curPath) {
	curPath = curPath.replace(/a\u030A/g, '').replace(/A\u030A/g, '');
	return curPath;
}

function rep7(curPath) {
	curPath = curPath.replace(/c\u0327/g, '').replace(/C\u0327/g, '');
	return curPath;
}